#include <stdlib.h>
#include <string.h>	
#include <avr/io.h>
#include <avr/interrupt.h>	

#define F_CPU 16000000

#include "uart-0.1.h"			
#include "mmc-0.2.h"			
#include "fat-0.4.h"						
#include "file-0.4.h"			


//*****************************************************************************************************************
// benchmark timer atmega168 @ 16.000.000mhz -> tick 10.000/sec
//*****************************************************************************************************************
unsigned int 	it=0;	//ms
unsigned char 	jt=0;	//sekunden
unsigned char 	nt=0;	//minuten
ISR(TIMER0_COMPA_vect){

	if(it++==10000){
		jt++;
		it=0;
		}

	if(jt==60){
		jt=0;
		nt=1;	
		}

}

//*****************************************************************************************************************
void main(void){

   

  while (mmc_init() !=0){;} 	//ist der Rückgabewert ungleich 0 ist ein Fehler aufgetreten	
	 
  if(0==fat_initfat()){			//ist der Rückgabewert ungleich 0 ist ein Fehler aufgetreten	
	

	char datei[12]="TEST    TXT";
	char dir[12]=  "DIR        ";

  	ffmkdir(dir);	// verzeichniss anlegen
	ffcd(dir);		// in verzeichniss wechseln
	
  	ffmkdir(dir);	// verzeichniss anlegen
	ffcd(dir);		// in verzeichniss wechseln
	
	
	// ************************************************************************************************* schreiben
	OCR0A =200;					// atmega168 -> 10.000 tick pro sec @ 16 mhz
	TCCR0A |= (1<<WGM01);	
	TCCR0B |= (1<<CS01);	
	TIMSK0 |= (1<<OCIE0A);		// compare interrupt an
	
	sei();	  
	
	unsigned int z;
	// neu erstellen wenn nicht vorhanden und reinscheiben
	if(0==ffopen('w',datei)){    	// prüfen ob öffnen erfolgreich und erst dann schreiben !
	  for(z=0;z<60000;z++){	
		ffwrite('a');	  
		}	
	  ffclose();
	  }

	cli();

	TCCR0A =0;
	TCCR0B =0;	
	OCR0A =0;

	

	uinit(); 

	char tmp[10];
	uputs("\n\rw-> s:");	
	uputs(utoa(jt,tmp,10));
	uputs(" ms:");	
	uputs(utoa(it/10,tmp,10));
	uputs("\n\r");		

	it=0;	//ms
	jt=0;	//sekunden
	nt=0;	//minuten



	// ************************************************************************************************* lesen
	OCR0A =200;					// atmega168 -> 10.000 tick pro sec @ 16 mhz
	TCCR0A |= (1<<WGM01);	
	TCCR0B |= (1<<CS01);	
	TIMSK0 |= (1<<OCIE0A);		// compare interrupt an
	
	sei();	
 
	if(0==ffopen('r',datei)){		// prüfen ob öffnen erfolgreich und erst dann lesen !
	  do{
		ffread();
		}while(--seek);  
	  ffclose();
	  }
	
	cli();

	TCCR0A =0;
	TCCR0B =0;	
	OCR0A =0;

	
	uputs("\n\rr-> s:");	
	uputs(utoa(jt,tmp,10));
	uputs(" ms:");	
	uputs(utoa(it/10,tmp,10));
	uputs("\n\r");		

	

 	}
}


